import numpy as np
import matplotlib.pyplot as plt

def euler_one_step (f, t, y, h):
    return y + h * f(t, y)

def heun_one_step (f, t, y, h):
    y1 = euler_one_step (f,t,y,h)
    return y + h * 0.5 * ( f(t, y) + f(t+h, y1))

def solve (f, t0, y0, tend, nsteps):
    h = (tend - t0) / nsteps
    time = np.linspace(t0, tend, nsteps)
    yn = y0
    y = []
    print (h)
    for t in time:
        y.append(yn)
        # change the method here
        yn = heun_one_step (f, t, yn, h)
    return [ time, y]

def dynamic (t, y):
    return np.array([-y[1], y[0]])

[t, y] = solve (dynamic, 0.0, np.array([1., 0.]), 2*np.pi*10, 500)

print (len(y))
fig, ax = plt.subplots()
plt.plot(t, y)

plt.xlabel('time')
plt.ylabel('Solution y')
plt.title("Simple Plot")
plt.legend()
plt.show()
